/* 

"@(#) $Id: amag_commandtomidas.c,v 1.2 2003/10/26 08:51:27 ohainaut Exp $"

  commandtomidas 

  send command to MIDAS session, 4. Oct. 1998

*/

#include "stdio.h"
#include "string.h"
#include <stdlib.h>
#include <unistd.h>

#include "midas_def.h"

int
main (int argc, char *argv[])
{
   char UNIT[10], COMMAND[60], DIR[128];
   int id, iwa=-1, retstat[2];
   int RTcount=0;
   int MaxReTries=3;
   int ReTrySleep=60; /* seconds */

   if (argc == 1)
     {
        printf("Usage: commandtomidas midasunit command\n");
        return(1);
     }

   strcpy(UNIT,argv[1]);
   strcpy(COMMAND,argv[2]);
  
   UNIT[3] = '\0';
   if ( strcmp(getenv("MID_WORK"),"") == 0 ) {
     strcpy(DIR,getenv("HOME"));
     strcat(DIR,"/midwork");
   } else {
     strcpy(DIR,getenv("MID_WORK"));
   }

   if ( XCZOPN(UNIT,"QX",DIR,&id) == 0) {
     while ( ( RTcount < MaxReTries ) && ( XCCSND(id,COMMAND,iwa,retstat) != 0 )
 ) {
       RTcount++;
       if ( RTcount < MaxReTries ) {
         printf("WARNING!!! Attempt %d/%d: MIDAS session %s appears to be busy, sleeping for %d seconds before trying again\n",RTcount,MaxReTries,UNIT,ReTrySleep);
         sleep(ReTrySleep);
       } else {
         printf("ERROR!!! Attempt %d/%d failed: MIDAS session %s appears to be busy.\n",RTcount,MaxReTries,UNIT);
         return(1);
       }
     }
     return(0);
   } else {
     printf("ERROR!!! Connection to MIDAS session %s failed\n",UNIT);
     return (1);
   }
}
